base/urls.py
from django.conf.urls import url

from base.views import homepage

urlpatterns = [
    url(r'^$', homepage, name='home'),
]

character/urls.py
from django.conf.urls import url
from django.contrib.auth.decorators import login_required

from character.views.actions import activate, public_order
from character.views.creation import CharacterCreationView, create
from character.views.inventory import InventoryView, transfer_cash
from character.views.pause import unpause, pause
from character.views.travel import TravelView, travel_view_iframe
from character.views.views import character_home, character_view, \
    character_view_iframe
from decorators import inchar_required

urlpatterns = [
    url(r'^create$', create, name='create'),
    url(r'^create/(?P<world_id>[0-9]+)$', login_required(CharacterCreationView.as_view()), name='create'),
    url(r'^activate/(?P<char_id>[0-9]+)$', activate, name='activate'),
    url(r'^pause$', pause, name='pause'),
    url(r'^unpause$', unpause, name='unpause'),
    url(r'^home$', character_home, name='character_home'),
    url(r'^travel/(?P<settlement_id>[0-9]+)?$', inchar_required(TravelView.as_view()), name='travel'),
    url(r'^travel_iframe/(?P<settlement_id>[0-9]+)?$', travel_view_iframe, name='travel_iframe'),
    url(r'^inventory$', inchar_required(InventoryView.as_view()), name='inventory'),
    url(r'^view/(?P<character_id>[0-9]+)$', character_view, name='character'),
    url(r'^view_iframe/(?P<character_id>[0-9]+)$', character_view_iframe, name='character_iframe'),
    url(r'^public_order$', public_order, name='public_order'),
    url(r'^transfer_cash$', transfer_cash, name='transfer_cash'),
]

finem_imperii/urls.py
from django.conf.urls import url, include
from django.contrib import admin

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^', include('base.urls', namespace='base'), name='base'),
    url(r'^', include('account.urls', namespace='account'), name='account'),
    url(r'^', include('world.urls', namespace='world'), name='world'),
    url(r'^character/', include('character.urls', namespace='character'), name='character'),
    url(r'^unit/', include('unit.urls', namespace='unit'), name='unit'),
    url(r'^messaging/', include('messaging.urls', namespace='messaging'), name='messaging'),
    url(r'^organization/', include('organization.urls', namespace='organization'), name='organization'),
    url(r'^battle/', include('battle.urls', namespace='battle'), name='battle'),
    url(r'^help/', include('help.urls', namespace='help'), name='help'),
]

organization/urls.py
from django.conf.urls import url

from decorators import inchar_required
from organization.views.heir import heir_capability_view
from organization.views.ban import banning_capability_view
from organization.views.conquest import conquest_capability_view
from organization.views.guilds import guilds_settings_capability_view
from organization.views.document import DocumentCapabilityView, document_view
from organization.views.diplomacy import DiplomacyCapabilityView
from organization.views.military_stance import MilitaryStanceCapabilityView
from organization.views.battle_formation import formation_capability_view
from organization.views.elections import elect_capability_view, \
    election_convoke_capability_view, \
    present_candidacy_capability_view, election_list_view, election_view
from organization.views.decorator import capability_required_decorator
from organization.views.proposal import ProposalView
from organization.views.capability import CapabilityView
from organization.views.organization import organization_view, leave_view

urlpatterns = [
    url(r'^(?P<organization_id>[0-9]+)$',
        organization_view, name='view'),
    url(r'^(?P<organization_id>[0-9]+)/elections$',
        election_list_view, name='election_list'),
    url(r'^(?P<organization_id>[0-9]+)/leave',
        leave_view, name='leave'),
    url(r'^election/(?P<election_id>[0-9]+)$',
        election_view, name='election'),
    url(r'^document/(?P<document_id>[0-9]+)$',
        document_view, name='document'),
    url(r'^proposal/(?P<proposal_id>[0-9]+)$',
        inchar_required(ProposalView.as_view()), name='proposal'),
    url(r'^capability/(?P<capability_id>[0-9]+)$',
        inchar_required(capability_required_decorator(CapabilityView.as_view())),
        name='capability'),
    url(r'^capability/(?P<capability_id>[0-9]+)/ban$',
        banning_capability_view, name='banning_capability'),
    url(r'^capability/(?P<capability_id>[0-9]+)/conquer',
        conquest_capability_view, name='conquest_capability'),
    url(r'^capability/(?P<capability_id>[0-9]+)/guilds',
        guilds_settings_capability_view, name='guilds_capability'),
    url(r'^capability/(?P<capability_id>[0-9]+)/formation',
        formation_capability_view, name='battle_formation_capability'),
    url(r'^capability/(?P<capability_id>[0-9]+)/convoke_elections',
        election_convoke_capability_view, name='election_convoke_capability'),
    url(r'^capability/(?P<capability_id>[0-9]+)/candidacy',
        present_candidacy_capability_view, name='candidacy_capability'),
    url(r'^capability/(?P<capability_id>[0-9]+)/elect',
        elect_capability_view, name='elect_capability'),
    url(r'^capability/(?P<capability_id>[0-9]+)/heir',
        heir_capability_view, name='heir_capability'),
    url(r'^capability/(?P<capability_id>[0-9]+)/document/(?P<document_id>[0-9]+)?$',
        inchar_required(capability_required_decorator(DocumentCapabilityView.as_view())),
        name='document_capability'),
    url(r'^capability/(?P<capability_id>[0-9]+)/diplomacy/(?P<target_organization_id>[0-9]+)$',
        inchar_required(capability_required_decorator(DiplomacyCapabilityView.as_view())),
        name='diplomacy_capability'),
    url(r'^capability/(?P<capability_id>[0-9]+)/stance/(?P<target_organization_id>[0-9]+)$',
        inchar_required(capability_required_decorator(MilitaryStanceCapabilityView.as_view())),
        name='military_stance_capability'),
]

unit/urls.py
from django.conf.urls import url

from decorators import inchar_required
from unit.views.actions import disband, conquest_action, rename, pay_debt
from unit.views.recruitment import RecruitmentView
from unit.views.settings import battle_settings, status_change
from unit.views.unit import unit_view

urlpatterns = [
    url(r'^recruit$', inchar_required(RecruitmentView.as_view()), name='recruit'),
    url(r'^(?P<unit_id>[0-9]+)$', unit_view, name='unit'),
    url(r'^(?P<unit_id>[0-9]+)/rename$', rename, name='rename'),
    url(r'^(?P<unit_id>[0-9]+)/battle_settings', battle_settings, name='battle_settings'),
    url(r'^(?P<unit_id>[0-9]+)/pay', pay_debt, name='pay_debt'),
    url(r'^(?P<unit_id>[0-9]+)/disband', disband, name='disband'),
    url(r'^(?P<unit_id>[0-9]+)/conquest', conquest_action, name='conquest_action'),
    url(r'^(?P<unit_id>[0-9]+)/(?P<new_status>[ a-z]+)', status_change, name='status_change'),
]

organization/models/document.py
from django.db import models
from django.urls import reverse
from django.utils.html import format_html


class PolicyDocument(models.Model):
    organization = models.ForeignKey('Organization')
    parent = models.ForeignKey(
        'PolicyDocument', related_name='children', null=True, blank=True)
    public = models.BooleanField(default=False)
    title = models.TextField(max_length=100)
    body = models.TextField()
    last_modified_turn = models.IntegerField()

    def __str__(self):
        return self.title

    def get_absolute_url(self):
        return reverse(
            'organization:document', kwargs={'document_id': self.id})

    def get_html_link(self):
        return format_html('<a href="{url}">{name}</a>',
                           url=self.get_absolute_url(),
                           name=self.title,
                           )

organization/views/ban.py
from django.contrib import messages
from django.shortcuts import get_object_or_404, redirect
from django.urls import reverse
from django.views.decorators.http import require_POST

from base.utils import redirect_back
from character.models import Character
from organization.models.capability import Capability
from organization.views.proposal import capability_success
from organization.views.decorator import capability_required_decorator


@require_POST
@capability_required_decorator
def banning_capability_view(request, capability_id):
    capability = get_object_or_404(
        Capability, id=capability_id, type=Capability.BAN)

    character_to_ban = get_object_or_404(
        Character, id=request.POST.get('character_to_ban_id'))
    if character_to_ban not in capability.applying_to.character_members.all():
        return redirect_back(request, reverse('character:character_home'),
                             error_message="You cannot do that")

    proposal = {'character_id': character_to_ban.id}
    capability.create_proposal(request.hero, proposal)
    return capability_success(capability, request)

organization/views/battle_formation.py
from django.http import Http404
from django.shortcuts import get_object_or_404
from django.views.decorators.http import require_POST

from battle.models import BattleFormation
from organization.models.capability import Capability
from organization.views.proposal import capability_success
from organization.views.decorator import capability_required_decorator


def check_line_formation_validity(request):
    element_size = int(request.POST['line_depth'])
    spacing = int(request.POST['line_spacing'])
    if not 0 < element_size <= 10 or not spacing <= 15:
        raise Http404("Invalid settings")
    return element_size, spacing


def check_column_formation_validity(request):
    element_size = int(request.POST['column_width'])
    spacing = int(request.POST['column_spacing'])
    if not 0 < element_size <= 10 or not spacing <= 15:
        raise Http404("Invalid settings")
    return element_size, spacing


def check_square_wedge_iwedge_formation_validity(request):
    element_size = None
    spacing = int(request.POST['square_spacing'])
    if not spacing <= 15:
        raise Http404("Invalid settings")
    return element_size, spacing


formation_validity_checks = {
    BattleFormation.LINE: check_line_formation_validity,
    BattleFormation.COLUMN: check_column_formation_validity,
    BattleFormation.SQUARE: check_square_wedge_iwedge_formation_validity,
    BattleFormation.WEDGE: check_square_wedge_iwedge_formation_validity,
    BattleFormation.IWEDGE: check_square_wedge_iwedge_formation_validity,
}


@require_POST
@capability_required_decorator
def formation_capability_view(request, capability_id):
    capability = get_object_or_404(
        Capability, id=capability_id, type=Capability.BATTLE_FORMATION)

    new_formation = request.POST['new_formation']
    if new_formation not in formation_validity_checks.keys():
        raise Http404("Invalid formation")
    else:
        element_size, spacing = formation_validity_checks[new_formation](
            request)

    proposal = {
        'formation': new_formation,
        'spacing': spacing,
        'element_size': element_size
    }
    capability.create_proposal(request.hero, proposal)
    return capability_success(capability, request)

organization/views/capability.py
from django.shortcuts import get_object_or_404, render
from django.views import View

from organization.models.capability import Capability
from organization.models.election import PositionCandidacy, \
    PositionElectionVote
from world.models.events import TileEvent


def candidacy_capability_context(request, capability, context):
    context['heros_candidacy'] = None
    if capability.applying_to.current_election:
        try:
            context['heros_candidacy'] = capability.applying_to. \
                current_election.positioncandidacy_set. \
                get(candidate=request.hero)
        except PositionCandidacy.DoesNotExist:
            pass


def elect_capability_context(request, capability, context):
    context['heros_vote'] = None
    if capability.applying_to.current_election:
        try:
            context['heros_vote'] = capability.applying_to.current_election. \
                positionelectionvote_set.get(voter=request.hero)
        except PositionElectionVote.DoesNotExist:
            pass


def diplomacy_capability_context(request, capability, context):
    if capability.applying_to.violence_monopoly:
        context['states'] = []
        for state in capability.applying_to.world.get_violence_monopolies():
            if state == capability.applying_to:
                continue
            state.relationship_out = state.get_relationship_from(
                capability.applying_to
            )
            state.relationship_in = state.get_relationship_to(
                capability.applying_to
            )
            context['states'].append(state)


def military_stance_capability_context(request, capability, context):
    if capability.applying_to.violence_monopoly:
        context['states'] = []
        for state in capability.applying_to.world.get_violence_monopolies():
            if state == capability.applying_to:
                continue
            state.default_stance = capability.applying_to. \
                get_default_stance_to(state)
            state.region_stances = capability.applying_to. \
                get_region_stances_to(state)
            context['states'].append(state)


def conquest_capability_context(request, capability, context):
    if capability.applying_to.violence_monopoly:
        context['conquestable_tiles'] = capability.applying_to. \
            conquestable_tiles()
        context['conquests_in_progress'] = TileEvent.objects.filter(
            organization=capability.applying_to,
            type=TileEvent.CONQUEST,
            end_turn=None
        )


class CapabilityView(View):
    context_decorators = {
        Capability.CANDIDACY: candidacy_capability_context,
        Capability.ELECT: elect_capability_context,
        Capability.DIPLOMACY: diplomacy_capability_context,
        Capability.MILITARY_STANCE: military_stance_capability_context,
        Capability.CONQUEST: conquest_capability_context,
    }

    def get(self, request, capability_id):
        capability = get_object_or_404(Capability, id=capability_id)

        context = {
            'capability': capability,
            'subtemplate': 'organization/capabilities/{}.html'.format(
                capability.type
            ),
        }

        if capability.type in self.context_decorators.keys():
            self.context_decorators[capability.type](
                request, capability, context
            )

        return render(request, 'organization/capability.html', context)

organization/views/conquest.py
from django.http import Http404
from django.shortcuts import get_object_or_404
from django.views.decorators.http import require_POST

from organization.models.capability import Capability
from organization.views.proposal import capability_success
from organization.views.decorator import capability_required_decorator
from world.models.events import TileEvent
from world.models.geography import Tile


@require_POST
@capability_required_decorator
def conquest_capability_view(request, capability_id):
    capability = get_object_or_404(
        Capability, id=capability_id, type=Capability.CONQUEST)
    tile_to_conquer = get_object_or_404(
        Tile,id=request.POST.get('tile_to_conquest_id'))

    if request.POST.get('stop'):
        try:
            tile_event = TileEvent.objects.get(
                tile=tile_to_conquer,
                organization=capability.applying_to,
                end_turn__isnull=True
            )
        except TileEvent.DoesNotExist:
            raise Http404
    else:
        if tile_to_conquer not in capability.applying_to.conquestable_tiles():
            raise Http404

    proposal = {
        'tile_id': tile_to_conquer.id,
        'stop': request.POST.get('stop')
    }
    capability.create_proposal(request.hero, proposal)
    return capability_success(capability, request)

organization/views/decorator.py
from django.contrib import messages
from django.shortcuts import redirect, get_object_or_404
from django.urls import reverse

from decorators import inchar_required
from organization.models.capability import Capability


def capability_required_decorator(func):
    @inchar_required
    def inner(*args, **kwargs):
        def fail_the_request(*args, **kwargs):
            messages.error(args[0], "You cannot do that", "danger")
            return redirect(
                args[0].META.get(
                    'HTTP_REFERER',
                    reverse('character:character_home')
                )
            )
        capability_id = kwargs.get('capability_id')
        if capability_id is None:
            capability_id = args[0].POST.get('capability_id')
        if capability_id is None:
            capability_id = args[0].GET.get('capability_id')
        capability = get_object_or_404(Capability, id=capability_id)
        if not capability.organization.character_can_use_capabilities(
                args[0].hero):
            return fail_the_request(*args, **kwargs)
        return func(*args, **kwargs)
    return inner

organization/templates/organization/capabilities/ban.html
<p>
    You have been granted the power to ban members of {{ capability.applying_to }}.
</p>

{% for member in capability.applying_to.character_members.all %}
    <form class="" role="form" method="post" action="{% url 'organization:banning_capability' capability.id %}">
        {% csrf_token %}
        <input type="hidden" name="character_to_ban_id" value="{{ member.id }}">
        <span class="form-group form-inline">
            {{ member }}
            <button type="submit" class="btn btn-danger btn-sm" onclick="return confirm('Are you sure?')">Ban</button>
        </span>
    </form>
{% empty %}
    <p>No members</p>
{% endfor %}

organization/templates/organization/capabilities/candidacy.html
<p>
    You have been granted the power to present yourself as a candidate to {{ capability.applying_to }}.
</p>
<p>
    This means that you are able to participate as a candidate in the elections and, eventually, be able to occupy the
    position of {{ capability.applying_to }}. Candidacies can be presented up to three months before the elections.
</p>

{% if not capability.applying_to.current_election %}
    <p>
        You can't present your candidacy in this moment as there is no election currently in progress.
    </p>
{% elif not capability.applying_to.current_election.can_present_candidacy %}
    <p>
        The period to present candidacies is over.
    </p>
{% elif heros_candidacy and heros_candidacy.retired %}
    <p>
        You retired your candidacy in these elections.
    </p>
{% else %}
    <form class="form-horizontal" method="post" action="{% url 'organization:candidacy_capability' capability.id %}">
        <fieldset>
            {% csrf_token %}

            {% if heros_candidacy %}
                <legend>Edit candidacy</legend>
            {% else %}
                <legend>Present candidacy</legend>
            {% endif %}

            <div class="form-group">
                <label for="description" class="col-lg-2 control-label">Your candidacy text</label>
                <div class="col-lg-10">
                    <textarea class="form-control"
                              name="description"
                              rows="20"
                              id="description"
                              placeholder="Why should others vote for you?"
                              maxlength="10000"
                    >{% if heros_candidacy %}{{ heros_candidacy.description }}{% endif %}</textarea>
                </div>
            </div>

            <div class="form-group">
                <div class="col-lg-10 col-lg-offset-2">
                    <button type="submit" class="btn btn-primary">
                        {% if heros_candidacy %}Update{% else %}Create{% endif %}
                    </button>
                </div>
            </div>

        </fieldset>
    </form>

    {% if heros_candidacy %}
        <form class="form-horizontal" method="post" action="{% url 'organization:candidacy_capability' capability.id %}">
            <fieldset>
                {% csrf_token %}
                <input type="hidden" name="retire" value="1">

                <div class="form-group">
                    <div class="col-lg-10 col-lg-offset-2">
                        <button type="submit"
                                class="btn btn-danger"
                                onclick="return confirm('Are you sure you want to retire your candidacy? You will not be able to undo this.')"
                        >Retire candidacy</button>
                    </div>
                </div>

            </fieldset>
        </form>
    {% endif %}

{% endif %}

organization/templates/organization/capabilities/conscript.html
<p>
    You have been granted the power to train and conscript troops in {{ capability.applying_to }}.
</p>
<p>
    To use this power, visit the <a href="{% url 'unit:recruit' %}">recruitment page</a>.
</p>

organization/templates/organization/capabilities/convoke elections.html
<p>
    You have been granted the power to convoke elections for the position of {{ capability.applying_to }}.
</p>


{% if capability.applying_to.current_election %}
    <p>
        You can't currently convoke elections because there is an
        <a href="{{ capability.applying_to.current_election.get_absolute_url }}">election already in progress</a>.
    </p>
{% else %}
    <form
            class="form-horizontal"
            method="post"
            action="{% url 'organization:election_convoke_capability' capability.id %}"
    >
        <fieldset>
            {% csrf_token %}

            <legend>Convoke</legend>

            <div class="form-group">
                <label for="months_to_election" class="col-lg-2 control-label">
                    Months until election
                </label>
                <div class="col-lg-10">
                    <input class="form-control"
                           id="months_to_election"
                           name="months_to_election"
                           type="number"
                           min="6"
                           max="18"
                           value="12"
                    >
                    <span class="help-block">
                        The elections will take place this many months (6 to 18) from the time they are convoked.
                    </span>
                </div>
            </div>

            <div class="form-group">
                <div class="col-lg-10 col-lg-offset-2">
                    <button type="submit" class="btn btn-primary">
                        Convoke
                    </button>
                </div>
            </div>

        </fieldset>
    </form>
{% endif %}

organization/templates/organization/capabilities/diplomacy.html
<p>
    You have been granted the power to conduct diplomacy as {{ capability.applying_to }}.
</p>

{% if capability.applying_to.violence_monopoly %}
    <h4>Realm relationships</h4>

    <table class="table table-striped">
        <thead>
            <tr>
                <td>Realm</td>
                <td>Current</td>
                <td>Proposals</td>
                <td>Actions</td>
            </tr>
        </thead>
        <tbody>
            {% for state in states %}
                <tr>
                    <td>{{ state.get_html_link|safe }}</td>
                    <td>{{ state.relationship_out.get_relationship_html|safe }}</td>
                    <td>
                        {% if state.relationship_in.is_proposal %}
                            Received: {{ state.relationship_in.get_desired_relationship_html|safe }}
                        {% endif %}

                        {% if state.relationship_out.is_proposal %}
                            Sent: {{ state.relationship_out.get_desired_relationship_html|safe }}
                        {% endif %}
                    </td>
                    <td>
                        {% if state.barbaric %}
                            <span class="small">- locked -</span>
                        {% else %}
                            <a
                                    href="{% url 'organization:diplomacy_capability' capability.id state.id %}"
                                    class="btn btn-sm btn-primary"
                            >
                                Conduct diplomacy
                            </a>
                        {% endif %}
                    </td>
                </tr>
            {% empty %}
                <tr><td>No other realms</td></tr>
            {% endfor %}
        </tbody>
    </table>
{% else %}
{% endif %}

organization/templates/organization/capabilities/diplomacy_target_subtemplate.html
<form class="" role="form" method="post" action="{% url 'organization:diplomacy_capability' capability.id target_organization.id %}">
    {% csrf_token %}
    <input type="hidden" name="target_relationship" value="{{ target_relationship }}">
    <span class="form-group form-inline">
        <button type="submit" class="btn btn-{{ button_type }} btn-sm" onclick="return confirm('Are you sure?')">
            {{ button_text }}
        </button>
    </span>
</form>

organization/templates/organization/capabilities/elect.html
<p>
    You have been granted to vote for the position {{ capability.applying_to }}.
</p>

{% if not capability.applying_to.current_election %}

    <p>
        You can't vote in this moment as there is no election currently in progress.
    </p>

{% else %}
    {% if capability.applying_to.current_election.can_present_candidacy %}
        <p class="alert alert-warning">
            Please note that up to two months before the election, new candidates may present themselves and existing
            candidates may retire.
        </p>
    {% endif %}

    {% for candidacy in capability.applying_to.current_election.positioncandidacy_set.all %}

        <div class="col-md-6">
            <form class="" role="form" method="post" action="{% url 'organization:elect_capability' capability.id %}">
                {% csrf_token %}
                <input type="hidden" name="candidacy_id" value="{{ candidacy.id }}">
                <div class="panel
                            {% if candidacy.retired %}panel-default
                            {% elif heros_vote.candidacy == candidacy %}panel-success
                            {% else %}panel-primary{% endif %}">
                    <div class="panel-heading">
                        <h3 class="panel-title">
                            {{ candidacy.candidate }}
                            {% if candidacy.candidate == capability.applying_to.get_position_occupier %}
                                - {{ capability.applying_to.get_html_link|safe }}
                            {% endif %}
                            {% if candidacy.retired %}(candidate retired)
                            {% elif heros_vote.candidacy == candidacy %}(you voted this)
                            {% endif %}
                        </h3>
                    </div>

                    <div class="panel-body">
                        <pre class="wrapping">{{ candidacy.description }}</pre>

                        {% if not heros_vote and not candidacy.retired %}
                            <span class="form-group form-inline">
                                <button
                                        type="submit"
                                        class="btn btn-primary btn-sm"
                                        onclick="return confirm('Are you sure?')"
                                >
                                    Vote {{ candidacy.candidate }}
                                </button>
                            </span>
                        {% elif heros_vote.candidacy == candidacy %}
                            <p>You voted for this candidate.</p>
                        {% endif %}
                    </div>
                </div>
            </form>
        </div>
    {% empty %}
        <p class="alert alert-warning">No candidates thus far!</p>
    {% endfor %}

{% endif %}

organization/templates/organization/capabilities/heir.html
<p>
    You have been granted to choose the heir to the position
    {{ capability.applying_to }}.
</p>

<form class="" role="form" method="post" action="{% url 'organization:heir_capability' capability.id %}">
    {% csrf_token %}
    <p>
        First heir:
        <select name="first_heir">
            {% if not capability.applying_to.heir_first %}
                <option value="-1">None</option>
            {% endif %}
            {% for candidate in capability.applying_to.get_heir_candidates %}
                <option value="{{ candidate.id }}">{{ candidate }}</option>
            {% endfor %}
        </select>
    </p>

    <p>
        Second heir:
        <select name="second_heir">
            {% if not capability.applying_to.heir_second %}
                <option value="-1">None</option>
            {% endif %}
            {% for candidate in capability.applying_to.get_heir_candidates %}
                <option value="{{ candidate.id }}">{{ candidate }}</option>
            {% endfor %}
        </select>
    </p>

    <p>
        <button
                type="submit"
                class="btn btn-primary"
                onclick="return confirm('Are you sure?')"
        >
            Set
        </button>
    </p>
</form>

organization/templates/organization/capabilities/policy.html
<p>
    You have been granted the power to write policy and law in {{ capability.applying_to }}.
</p>
<p>
    This means that you may create, update and delete its policy documents.
</p>

<h4>Document list</h4>
<ul>
    {% for document in capability.applying_to.policydocument_set.all %}
        <li>
            <a href="{% url 'organization:document_capability' capability.id document.id %}">{{ document.title }}</a>
        </li>
    {% empty %}
        <li>Currently no documents exist.</li>
    {% endfor %}
</ul>

<p>
    <a class="btn btn-primary" href="{% url 'organization:document_capability' capability.id %}">Create new document</a>
</p>

organization/templates/organization/capabilities/take grain.html
<p>
    You have been granted the take grain from public granaries in
    {{ capability.applying_to }}.
</p>
<p>
    To use this power, visit the
    <a href="{% url 'character:inventory' %}">inventory</a>.
</p>